# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from datetime import datetime
from datetime import date
from pprint import pformat
import re
import json

from ..utils import sanitize_for_serialization

# type hinting support
from typing import TYPE_CHECKING
from typing import List
from typing import Dict


class ConversationInsight(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self) -> None:
        """
        ConversationInsight - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',
            'title': 'str',
            'description': 'str',
            'outcome': 'str'
        }

        self.attribute_map = {
            'type': 'type',
            'title': 'title',
            'description': 'description',
            'outcome': 'outcome'
        }

        self._type = None
        self._title = None
        self._description = None
        self._outcome = None

    @property
    def type(self) -> str:
        """
        Gets the type of this ConversationInsight.
        The type of insight

        :return: The type of this ConversationInsight.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type: str) -> None:
        """
        Sets the type of this ConversationInsight.
        The type of insight

        :param type: The type of this ConversationInsight.
        :type: str
        """
        if isinstance(type, int):
            type = str(type)
        allowed_values = ["Reason", "Resolution", "ActionItem"]
        if type.lower() not in map(str.lower, allowed_values):
            # print("Invalid value for type -> " + type)
            self._type = "outdated_sdk_version"
        else:
            self._type = type

    @property
    def title(self) -> str:
        """
        Gets the title of this ConversationInsight.
        The reason for contact, resolution for the interaction, or follow-up action item

        :return: The title of this ConversationInsight.
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title: str) -> None:
        """
        Sets the title of this ConversationInsight.
        The reason for contact, resolution for the interaction, or follow-up action item

        :param title: The title of this ConversationInsight.
        :type: str
        """
        

        self._title = title

    @property
    def description(self) -> str:
        """
        Gets the description of this ConversationInsight.
        Reasoning for the given insight

        :return: The description of this ConversationInsight.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description: str) -> None:
        """
        Sets the description of this ConversationInsight.
        Reasoning for the given insight

        :param description: The description of this ConversationInsight.
        :type: str
        """
        

        self._description = description

    @property
    def outcome(self) -> str:
        """
        Gets the outcome of this ConversationInsight.
        The outcome of a given resolution insight

        :return: The outcome of this ConversationInsight.
        :rtype: str
        """
        return self._outcome

    @outcome.setter
    def outcome(self, outcome: str) -> None:
        """
        Sets the outcome of this ConversationInsight.
        The outcome of a given resolution insight

        :param outcome: The outcome of this ConversationInsight.
        :type: str
        """
        

        self._outcome = outcome

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in self.swagger_types.items():
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_json(self):
        """
        Returns the model as raw JSON
        """
        return json.dumps(sanitize_for_serialization(self.to_dict()))

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

